using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.IO;
using System.Windows.Forms;
using Asukaze.CassavaNET.IO;

namespace Asukaze.CassavaNET
{
	/// <summary>
	///  UserControl ̊Tv̐
	/// </summary>
	public class CsvGrid : System.Windows.Forms.UserControl
	{
    #region TuNX

    class CellPosition {
    	public int x, y, cellLeft, cellTop;
      public bool colBorder, rowBorder;
      public bool isFixed;
      public bool outSide;
      public CellPosition() {
        x=0; y=0;
        colBorder=false; rowBorder=false;
        isFixed=false; outSide=false;
      }
      public CellPosition(CellPosition src) {
        CopyFrom(src);
      }
      public static CellPosition Guess(int x, int y, CsvGrid grid){
        CellPosition cp = new CellPosition();
      	grid.MouseToCellX(x, cp);
      	grid.MouseToCellY(y, cp);
        return cp;
      }
      public void ReGuess(int x, int y, CsvGrid grid){
        colBorder=false; rowBorder=false;
        isFixed=false; outSide=false;
	     	grid.MouseToCellX(x, this);
      	grid.MouseToCellY(y, this);
      }
      public void CopyFrom(CellPosition src){
        this.x=src.x;
        this.y=src.y;
        this.colBorder=src.colBorder;
        this.rowBorder=src.rowBorder;
        this.isFixed=src.isFixed;
        this.outSide=src.outSide;
      }
    }

    class Selection : Range{
      public Selection() : base() {}
      public Selection(int left, int top, int right, int bottom)
      : base(left, top, right, bottom) {}
      public Selection(Range r) : base(r) {}
      public Selection(CellPosition cp){
        Left   = cp.x;
        Top    = cp.y;
        Right  = cp.x;
        Bottom = cp.y;
      }

      public bool Inside(CellPosition cp){
        return Inside(cp.x, cp.y);
      }
      public CellPosition ToCellPosition(){
        CellPosition cp = new CellPosition();
        cp.x = Left; cp.y = Top;
        return cp;
      }
    }

    enum MouseAction {
      None = 0,
      ColResize, RowResize,
      ColMove, RowMove,
      RangeSelect, ColsSelect, RowsSelect
    }

    #endregion

    #region fUCiϐERXgN^EDispose

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel pnlRight;
		private System.Windows.Forms.PictureBox pictRB;
		private System.Windows.Forms.VScrollBar scrVert;
		private System.Windows.Forms.HScrollBar scrHorz;
		private System.Windows.Forms.TextBox inlineEdit;

		public CsvGrid()
		{
			// ̌ĂяóCWindows.Forms fUCiŕKvłB
			InitializeComponent();

      mouseAction = MouseAction.None;
      selection = null;
      view = new Selection();
      pnlMain = this;
      editpos = new CellPosition();
      rangepos = new CellPosition();
      goOutEdit();
   		this.SetStyle(ControlStyles.DoubleBuffer |
      	ControlStyles.UserPaint |
      	ControlStyles.AllPaintingInWmPaint,
      	true);
      this.UpdateStyles();
		}

		/// <summary>
		/// gpĂ郊\[X̌㏈s܂B
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
					components.Dispose();
			}
			base.Dispose(disposing);
		}

    #endregion

		#region R|[lg fUCiŐꂽR[h
		/// <summary>
		/// fUCiT|[gɕKvȃ\bhłB̃\bh̓e
		/// R[hGfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.pnlRight = new System.Windows.Forms.Panel();
			this.scrVert = new System.Windows.Forms.VScrollBar();
			this.pictRB = new System.Windows.Forms.PictureBox();
			this.scrHorz = new System.Windows.Forms.HScrollBar();
			this.inlineEdit = new System.Windows.Forms.TextBox();
			this.pnlRight.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlRight
			// 
			this.pnlRight.Controls.Add(this.scrVert);
			this.pnlRight.Controls.Add(this.pictRB);
			this.pnlRight.Dock = System.Windows.Forms.DockStyle.Right;
			this.pnlRight.Location = new System.Drawing.Point(136, 0);
			this.pnlRight.Name = "pnlRight";
			this.pnlRight.Size = new System.Drawing.Size(14, 150);
			this.pnlRight.TabIndex = 0;
			// 
			// scrVert
			// 
			this.scrVert.Dock = System.Windows.Forms.DockStyle.Fill;
			this.scrVert.LargeChange = 1;
			this.scrVert.Location = new System.Drawing.Point(0, 0);
			this.scrVert.Maximum = 4;
			this.scrVert.Minimum = 1;
			this.scrVert.Name = "scrVert";
			this.scrVert.Size = new System.Drawing.Size(14, 136);
			this.scrVert.TabIndex = 0;
			this.scrVert.Value = 1;
			this.scrVert.ValueChanged += new System.EventHandler(this.scr_ValueChanged);
			// 
			// pictRB
			// 
			this.pictRB.BackColor = System.Drawing.SystemColors.Control;
			this.pictRB.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pictRB.Location = new System.Drawing.Point(0, 136);
			this.pictRB.Name = "pictRB";
			this.pictRB.Size = new System.Drawing.Size(14, 14);
			this.pictRB.TabIndex = 0;
			this.pictRB.TabStop = false;
			// 
			// scrHorz
			// 
			this.scrHorz.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.scrHorz.LargeChange = 1;
			this.scrHorz.Location = new System.Drawing.Point(0, 136);
			this.scrHorz.Maximum = 4;
			this.scrHorz.Minimum = 1;
			this.scrHorz.Name = "scrHorz";
			this.scrHorz.Size = new System.Drawing.Size(136, 14);
			this.scrHorz.TabIndex = 2;
			this.scrHorz.Value = 1;
			this.scrHorz.ValueChanged += new System.EventHandler(this.scr_ValueChanged);
			this.scrHorz.Scroll += new System.Windows.Forms.ScrollEventHandler(this.scr_Scroll);
			// 
			// inlineEdit
			// 
			this.inlineEdit.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.inlineEdit.Location = new System.Drawing.Point(8, 8);
			this.inlineEdit.Multiline = true;
			this.inlineEdit.Name = "inlineEdit";
			this.inlineEdit.TabIndex = 0;
			this.inlineEdit.Text = "";
			this.inlineEdit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.inlineEdit_KeyDown);
			this.inlineEdit.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.inlineEdit_KeyPress);
			// 
			// CsvGrid
			// 
			this.BackColor = System.Drawing.Color.White;
			this.Controls.Add(this.scrHorz);
			this.Controls.Add(this.pnlRight);
			this.Controls.Add(this.inlineEdit);
			this.Name = "CsvGrid";
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pnlMain_MouseUp);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.pnlMain_Paint);
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.inlineEdit_KeyDown);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pnlMain_MouseMove);
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pnlMain_MouseDown);
			this.pnlRight.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion

    #region vCx[g o
    private CassavaU data;
    private CellPosition editpos, mousepos, rangepos;
    private MouseAction mouseAction;
    private Selection selection, view;
    private Control pnlMain;
    private bool editing;

    #endregion

    #region pubN vpeB
    public CassavaU DataSource {
      get { return data; }
      set {
        data = value;
        if(data == null){
         	goOutEdit();
        }else{
          setCursol(1,1);
        	changeEdit(EditorSelectMode.All);
        }
        Refresh();
      }
    }

    public int TopRow {
     	get { return scrVert.Value; }
//      set { scrVert.Value = value; }
    }

    public int LeftCol {
     	get { return scrHorz.Value; }
//      set { scrHorz.Value = value; }
    }

    public int Row {
     	get { return editpos.y; }
      set {
        if(value > scrVert.Maximum){ scrVert.Maximum = value; }
      	editpos.y = value;
        if(selection != null){
          selection.SetValue(editpos.x, editpos.y, editpos.x, editpos.y);
        }
      }
    }

    public int Col {
      get { return editpos.x; }
      set {
        if(value > scrHorz.Maximum){ scrHorz.Maximum = value; }
      	editpos.x = value;
        if(selection != null){
          selection.SetValue(editpos.x, editpos.y, editpos.x, editpos.y);
        }
      }
   	}

    private void setCursol(int x, int y){
     	editpos.x = x;
    	editpos.y = y;
      if(selection != null){
        selection.SetValue(editpos.x, editpos.y, editpos.x, editpos.y);
      }
    }

    public int SelLeft{
      get{
        if(selection == null){ return Col; }
        return selection.Left;
      }
      set{
        if(selection != null){
          selection.Left = value;
        }
      }
    }

    public int SelTop{
      get{
        if(selection == null){ return Row; }
        return selection.Top;
      }
      set{
        if(selection != null){
          selection.Top = value;
        }
      }
    }

    public int SelRight{
      get{
        if(selection == null){ return Col; }
        return selection.Right;
      }
      set{
        if(selection != null){
          selection.Right = value;
        }
      }
    }
    public int SelBottom{
      get{
        if(selection == null){ return Row; }
        return selection.Bottom;
      }
      set{
        if(selection != null){
          selection.Bottom = value;
        }
      }
    }

    #endregion

    #region pubN \bh
    public void BeginEditing(){
      if(editing && inlineEdit != null){
        inlineEdit.Select(inlineEdit.TextLength, 0);
      }else if(!editing && selection != null){
  		  startEdit(selection.ToCellPosition());
      }
    }
    public void EndEditing(){
     	endEdit();
    }
    public void UpdateEditing(){
      if(editing && inlineEdit != null && editpos != null){
        data.SetCell(editpos.x, editpos.y, inlineEdit.Text);
      }
    }
    public bool IsEditing(){
      return editing;
    }

    public void Cut(Setting setting){
      if(editing && inlineEdit != null){
        inlineEdit.Cut();
      }else{
        cutCopyToClipBoard(setting, true);
      }
    }
    public void Copy(Setting setting){
      if(editing && inlineEdit != null){
        inlineEdit.Copy();
      }else{
        cutCopyToClipBoard(setting, false);
      }
    }
    public void Paste(Setting setting){
      pasteFromClipboard(setting);
    }
    public void Select(int left, int top, int right, int bottom){
      endEdit();
      selection = new Selection(left, top, right, bottom);
      if(!selection.Inside(editpos)){ editpos = selection.ToCellPosition();}
      pnlMain.Refresh();
    }
    public void Select(Range r){
      endEdit();
      selection = new Selection(r);
      if(!selection.Inside(editpos)){ editpos = selection.ToCellPosition();}
      pnlMain.Refresh();
    }
    public void SelectAll(){
      endEdit();
      selection = new Selection(1, 1, viewColCount, viewRowCount);
      pnlMain.Refresh();
    }
    public void SelectRows(int top, int bottom){
      endEdit();
      selection.SetValue(1, top, viewColCount, bottom);
      if(!selection.Inside(editpos)){ editpos = selection.ToCellPosition();}
      pnlMain.Refresh();
    }
    public void SelectCols(int left, int right){
      endEdit();
      selection.SetValue(left, 1, right, viewRowCount);
      if(!selection.Inside(editpos)){ editpos = selection.ToCellPosition();}
      pnlMain.Refresh();
    }

    #endregion

    #region vCx[g \bh
    private int viewColCount{
      get {
        int colCount = data.GetColCount();
      	if(editing){
        	if(editpos.x > colCount){ colCount = editpos.x; }
 		    }
        if(selection != null){
        	if(selection.Right > colCount){ colCount = selection.Right; }
        }
	      if(scrHorz.Value > colCount){ colCount = scrHorz.Value; }
        return colCount;
      }
    }

    private int viewRowCount{
      get {
        int rowCount = data.GetRowCount();
      	if(editing){
        	if(editpos.y > rowCount){ rowCount = editpos.y; }
 		    }
        if(selection != null){
        	if(selection.Bottom > rowCount){ rowCount = selection.Bottom; }
        }
	      if(scrVert.Value > rowCount){ rowCount = scrVert.Value; }
        return rowCount;
      }
    }

    private void gridPaint(Graphics g) {
    	const int margin = 5;
    	int wid = pnlMain.Width;
      int hei = pnlMain.Height;

      g.Clear(SystemColors.Window);
      g.DrawLine(Pens.Black, 0, 1, wid, 1);
      g.DrawLine(Pens.Black, 1, 0, 1, hei);
      g.DrawLine(Pens.Gray, 0, 0, wid, 0);
      g.DrawLine(Pens.Gray, 0, 0, 0, hei);

      if(data == null){ return; }

      int colCount = viewColCount;
      int rowCount = viewRowCount;
      int fxRows = data.FixedRows;
      int fxCols = data.FixedCols;
      view.Top = TopRow;
      view.Left = LeftCol;
      int px = 2;
      int py = 2;
      int ix = 1, iy = 1;
      bool iexok = (!editing || editpos == null);
      bool ieyok = iexok;

      scrHorz.Maximum = colCount;
      scrVert.Maximum = rowCount;

      for(iy=(fxRows <= 0 ? 0 : 1); iy <= rowCount && py < hei; iy++){
        int cellheight = data.GetRowHeight(iy);
        int pb = py + cellheight;

        if(!ieyok && editpos.y == iy){
          editpos.cellTop = py;
          ieyok = true;
        }

 	      for(ix=(fxCols <= 0 ? 0 : 1); ix <= colCount && px < wid; ix++){
          int cellwidth = data.GetColWidth(ix);
          int pr = px + cellwidth;
          Rectangle rect = new Rectangle(px + 2, py + 2, cellwidth - margin, cellheight - margin);

        	if(!iexok && editpos.x == ix){
      	    editpos.cellLeft = px;
  	        iexok = true;
	        }

          if(ix <= fxCols || iy <= fxRows){
            g.FillRectangle(Brushes.Silver, px, py, cellwidth, cellheight);
            string val;
            if(ix == 0){
              if(iy == 0){ val = ""; }
              else       { val = iy.ToString(); }
            }else{
              if(iy == 0){ val = ix.ToString(); }
              else       { val = data.GetCell(ix, iy); }
            }
            writeCell(g, rect, Brushes.Black, val);
	          g.DrawLine(Pens.White, px, py, pr - 1, py);
            g.DrawLine(Pens.White, px, py, px, pb - 1);
            g.DrawLine(Pens.Gray, px, pb - 2, pr - 2, pb - 2);
            g.DrawLine(Pens.Gray, pr - 2, py, pr - 2, pb - 2);
            g.DrawLine(Pens.Black, px, pb - 1, pr - 1, pb - 1);
            g.DrawLine(Pens.Black, pr - 1, py, pr - 1, pb - 1);
          }else{
            Brush brush = Brushes.Black;
            if(selection != null && selection.Inside(ix, iy)){
              g.FillRectangle(SystemBrushes.HotTrack, px, py, cellwidth, cellheight);
              brush = Brushes.White;
            }
            writeCell(g, rect, brush, data.GetCell(ix, iy));
            g.DrawLine(Pens.Silver, px, pb - 1, pr - 1, pb - 1);
            g.DrawLine(Pens.Silver, pr - 1, py, pr - 1, pb - 1);
            if(ix == editpos.x && iy == editpos.y){
             	g.DrawRectangle(Pens.Silver, px, py, cellwidth-2, cellheight-2);
            }
          }
          px = pr;
	      	if(ix == fxCols){ ix = view.Left - 1; }
  	    }
        py = pb;
        px = 2;
      	if(iy == fxRows){ iy = view.Top - 1; }
	   	}

      view.Right = ix - 1;
      view.Bottom = iy - 1;
      scrHorz.LargeChange = Math.Max(ix - view.Left - 1, 1);
      scrVert.LargeChange = Math.Max(iy - view.Top - 1, 1);

      if(editing){
      	if(iexok && ieyok){
        	moveEdit();
        }else{
 					goOutEdit();
        }
      }
   	}

    private void writeCell(Graphics g, Rectangle rect, Brush brush, string val) {
      if(rect.Width > 0 && rect.Height > 0){
        g.DrawString(val, this.Font, brush, rect);
      }
    }

    private void MouseToCellX(int x, CellPosition cp){
      int colCount = viewColCount;
      int fxCols = data.FixedCols;
      int leftCol = LeftCol;
      int px = 6;
      int left = 2;

 		  for(int ix=(fxCols <= 0 ? 0 : 1); ix <= colCount; ix++){
        px += data.GetColWidth(ix);
        if(x < px){
          cp.x = ix;
          cp.cellLeft = left;
          cp.colBorder = (x >= px - 8);
          if(ix <= fxCols){ cp.isFixed = true; }
        	return;
        }
        left = px - 4;
      	if(ix == fxCols){ ix = leftCol - 1; }
      }
      cp.x = colCount + 1;
    	cp.outSide = true;
      return;
    }

    private void MouseToCellY(int y, CellPosition cp){
      int rowCount = viewRowCount;
      int fxRows = data.FixedRows;
      int topRow = TopRow;
      int py = 6;
      int top = 2;

 		  for(int iy=(fxRows <= 0 ? 0 : 1); iy <= rowCount; iy++){
        py += data.GetRowHeight(iy);
        if(y < py){
          cp.y = iy;
          cp.cellTop = top;
          cp.rowBorder = (y >= py - 8);
          if(iy <= fxRows){ cp.isFixed = true; }
          return;
        }
        top = py - 4;
    		if(iy == fxRows){ iy = topRow - 1; }
      }
      cp.y = rowCount + 1;
      cp.outSide = true;
      return;
    }

    private void autoScroll(CellPosition cp, bool slowmove) {
      CellPosition cpmove = CellPosition.Guess(pnlMain.Width, pnlMain.Height, this);
      if(cp.x < scrHorz.Value && cp.x >= scrHorz.Minimum){
      	if(slowmove){ scrHorz.Value--; }
        else        { scrHorz.Value = cp.x; }
      }else if(cpmove.x <= cp.x && cpmove.x > scrHorz.Value){
      	if(slowmove){ scrHorz.Value++; }
        else        { scrHorz.Value += (cp.x - cpmove.x + 1); }
      }

      if(cp.y < scrVert.Value && cp.y >= scrVert.Minimum){
      	if(slowmove){ scrVert.Value--; }
        else        { scrVert.Value = cp.y; }
      }else if(cpmove.y <= cp.y && cpmove.y > scrVert.Value){
      	if(slowmove){ scrVert.Value++; }
        else        { scrVert.Value += (cp.y - cpmove.y + 1); }
      }
    }

    private void swap(ref int a, ref int b){
      int temp = a;
      a = b;
      b = temp;
    }

    #endregion

    #region Cxgnh
		private void pnlMain_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
      Bitmap bmp = new Bitmap(pnlMain.Width, pnlMain.Height);
      Graphics g = Graphics.FromImage(bmp);
    	gridPaint(g);
      e.Graphics.DrawImage(bmp,0,0);
  	}

		private void scr_ValueChanged(object sender, System.EventArgs e)
		{
      pnlMain.Refresh();
		}

		private void scr_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
      pnlMain.Refresh();
		}

    private void endEdit() {
      if(editing && editpos != null){
        data.SetCell(editpos.x, editpos.y, inlineEdit.Text);
        inlineEdit.Text = "";
        goOutEdit();
 	     	editing = false;
        selection = new Selection(editpos);
      }
    }

    private void moveEdit() {
      inlineEdit.Width  = data.GetColWidth(editpos.x);
      inlineEdit.Height = data.GetRowHeight(editpos.y);
      inlineEdit.Left   = editpos.cellLeft;
      inlineEdit.Top    = editpos.cellTop;
    }

    enum EditorSelectMode{ None, All, After };
    private void changeEdit(EditorSelectMode esm) {
     	autoScroll(editpos, false);
      selection = null;

      inlineEdit.Text   = data.GetCell(editpos.x, editpos.y);
      if(esm == EditorSelectMode.All){
        inlineEdit.SelectAll();
      }else if(esm == EditorSelectMode.After){
        inlineEdit.Select(inlineEdit.TextLength, 0);
      }
      editing = true;
      pnlMain.Refresh();
    }

    private void startEdit(CellPosition cp, EditorSelectMode mode) {
      endEdit();
      editpos.CopyFrom(cp);
      moveEdit();
      changeEdit(mode);
    }

    private void startEdit(CellPosition cp) {
      startEdit(cp, EditorSelectMode.After);
    }

    private void goOutEdit() {
     	inlineEdit.Top = -2 * inlineEdit.Height;
    }

		private void pnlMain_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
      mousepos = CellPosition.Guess(e.X, e.Y, this);
      if(mousepos.outSide){ return; }
      if(mousepos.isFixed){
        if(mousepos.colBorder){
          mouseAction = MouseAction.ColResize;
        }else if(mousepos.rowBorder) {
          mouseAction = MouseAction.RowResize;
        }else{
          if(mousepos.x <= data.FixedCols){
            if(mousepos.y <= data.FixedRows) {
              SelectAll();
              pnlMain.Refresh();
              mouseAction = MouseAction.None;
            }else{
		          SelectRows(mousepos.y, mousepos.y);
              pnlMain.Refresh();
              mouseAction = MouseAction.RowsSelect;
            }
          }else if(mousepos.y <= data.FixedRows) {
	          SelectCols(mousepos.x, mousepos.x);
            pnlMain.Refresh();
            mouseAction = MouseAction.ColsSelect;
          }
        }
      }else{
	      endEdit();
	      selection = new Selection();
        setCursol(mousepos.x, mousepos.y);
        rangepos.CopyFrom(mousepos);
        mouseAction = MouseAction.RangeSelect;
        pnlMain.Refresh();
      }
		}

		private void pnlMain_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
      CellPosition cpmove = CellPosition.Guess(e.X, e.Y, this);
      if(mouseAction == MouseAction.None){
	      if(!cpmove.outSide && !cpmove.isFixed){
          startEdit(cpmove, EditorSelectMode.All);
        }
      }else if(mouseAction == MouseAction.RangeSelect){
	      if(!cpmove.outSide && !cpmove.isFixed &&
           cpmove.x == mousepos.x && cpmove.y == mousepos.y){
          startEdit(cpmove, EditorSelectMode.All);
        }
      }
      mouseAction = MouseAction.None;
		}

		private void pnlMain_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
      CellPosition cpmove = CellPosition.Guess(e.X, e.Y, this);
    	if(mouseAction == MouseAction.None){
      	if(cpmove.outSide == false && cpmove.isFixed){
        	if(cpmove.colBorder) {
         		Cursor.Current = Cursors.VSplit;
        	}else if(cpmove.rowBorder) {
          	Cursor.Current = Cursors.HSplit;
        	}else{
          	Cursor.Current = Cursors.Default;
        	}
      	}else{
        	Cursor.Current = Cursors.Default;
      	}
      }else if(mouseAction == MouseAction.ColResize){
        int wid = e.X - mousepos.cellLeft;
        if(wid > 0){ data.SetColWidth(mousepos.x, wid); }
     		Cursor.Current = Cursors.VSplit;
        pnlMain.Refresh();
      }else if(mouseAction == MouseAction.RowResize){
        int hei = e.Y - mousepos.cellTop;
        if(hei > 0){ data.SetRowHeight(mousepos.y, hei); }
       	Cursor.Current = Cursors.HSplit;
        pnlMain.Refresh();
      }else if(mouseAction == MouseAction.RangeSelect){
        selection.SetValue(mousepos.x, mousepos.y, cpmove.x, cpmove.y);
        pnlMain.Refresh();
      }else if(mouseAction == MouseAction.ColsSelect){
        SelectCols(mousepos.x, cpmove.x);
        pnlMain.Refresh();
      }else if(mouseAction == MouseAction.RowsSelect){
        SelectRows(mousepos.y, cpmove.y);
        pnlMain.Refresh();
      }
		}

    private bool IsArrowKey(Keys key){
      return (key == Keys.Left || key == Keys.Right || key == Keys.Up || key == Keys.Down);
    }

    private int VX(Keys key){
      if(key == Keys.Left){ return -1;}
      else if(key == Keys.Right){ return 1;}
      return 0;
    }

    private int VY(Keys key){
      if(key == Keys.Up){ return -1;}
      else if(key == Keys.Down){ return 1;}
      return 0;
    }

		private void inlineEdit_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
    	if(!editing && selection != null){
        if(!selection.Inside(editpos.x, editpos.y)){
  		    editpos = selection.ToCellPosition();
        }
        e.Handled = true;
      }

      if(!e.Shift && !e.Control && !e.Alt){
        if(e.KeyData == Keys.Enter && editing && inlineEdit.SelectionLength == inlineEdit.TextLength){
          inlineEdit.SelectionStart = inlineEdit.TextLength;
          e.Handled = true;
        }else if(e.KeyData == Keys.Escape ||
                (e.KeyData == Keys.Enter && editing)){
          endEdit();
          e.Handled = true;
        }else if(e.KeyData == Keys.Enter && !editing){
          if(selection != null){
            if(selection.Inside(editpos.x, editpos.y)){
              startEdit(editpos);
            }else{
					    startEdit(selection.ToCellPosition());
            }
            e.Handled = true;
          }
        }else if(e.KeyData == Keys.Up && editpos.y > data.FixedRows + 1){
          if(editing){
            data.SetCell(editpos.x, editpos.y, inlineEdit.Text);
          	editpos.y--;
	        	goOutEdit();
          	changeEdit(EditorSelectMode.All);
          }else{
            Row--;
            startEdit(editpos);
          }
          e.Handled = true;
			  }else if(e.KeyData == Keys.Down){
          if(scrVert.Value == scrVert.Maximum) {
           scrVert.Maximum++;
          }
          if(editing){
            data.SetCell(editpos.x, editpos.y, inlineEdit.Text);
  	        editpos.y++;
	  	      goOutEdit();
      	    changeEdit(EditorSelectMode.All);
          }else{
            Row++;
            startEdit(editpos);
          }
	        e.Handled = true;
			  }else if(e.KeyData == Keys.Left && editpos.x > data.FixedCols + 1) {
          if(editing){
        	  if(inlineEdit.SelectionStart > 0) { return; }
					  data.SetCell(editpos.x, editpos.y, inlineEdit.Text);
  	     	  editpos.x--;
	  	   	  goOutEdit();
      	 	  changeEdit(EditorSelectMode.All);
          }else{
            Col--;
            startEdit(editpos);
          }
          e.Handled = true;
			  }else if(e.KeyData == Keys.Right) {
          if(scrHorz.Value == scrHorz.Maximum) {
            scrHorz.Maximum++;
          }
          if(editing){
            if(inlineEdit.SelectionStart + inlineEdit.SelectionLength
          	   < inlineEdit.Text.Length) { return; }
            data.SetCell(editpos.x, editpos.y, inlineEdit.Text);
  	  	    editpos.x++;
			      goOutEdit();
	    	    changeEdit(EditorSelectMode.All);
          }else{
            Col++;
            startEdit(editpos);
          }
          e.Handled = true;
        }
      }else if(e.Shift && !e.Control && !e.Alt){
        if(IsArrowKey(e.KeyCode)){
          if(editing){
            if(inlineEdit.SelectionLength < inlineEdit.TextLength){ return; }
            endEdit();
          }
          if(selection.Size == 1){
            rangepos = selection.ToCellPosition();
          }
          editpos.x = Math.Max(editpos.x + VX(e.KeyCode),1);
          editpos.y = Math.Max(editpos.y + VY(e.KeyCode),1);
          selection.SetValue(editpos.x, editpos.y, rangepos.x, rangepos.y);
          e.Handled = true;
        }
      }

      autoScroll(editpos,false);
      pnlMain.Refresh();
		}

		private void inlineEdit_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if(e.KeyChar == '\n' || e.KeyChar == '\r'){
        e.Handled = true;
      }
		}

    #endregion

    #region vCx[g \bhit@\j
    private void cutCopyToClipBoard(Setting setting, bool cut){
      int L = selection.Left;
      int T = selection.Top;
      int W = selection.Right - L + 1;
      int H = selection.Bottom - T + 1;

      if(cut){ data.BeginUndoSequense(); }
      CassavaImpl clip = new CassavaImpl(W, H);
      for(int y = 1; y <= H; y++){
        for(int x = 1; x <= W; x++){
          clip.SetCell(x, y, data.GetCell(x+L-1, y+T-1));
  	      if(cut){ data.SetCell(x+L-1, y+T-1, ""); }
        }
      }
      if(cut){ data.EndUndoSequense(); }

      using(StringWriter sw = new StringWriter()){
        CsvWriter.Write(sw, setting.FileFormat, clip);
        Clipboard.SetDataObject(sw.ToString());
      }
      pnlMain.Refresh();
    }

    private void pasteFromClipboard(Setting setting){
      IDataObject obj = Clipboard.GetDataObject();
      FileFormat format = setting.FileFormat;
      string str;
      if(obj.GetDataPresent(DataFormats.CommaSeparatedValue)){
        str = obj.GetData(DataFormats.CommaSeparatedValue).ToString();
        format = new FileFormat("CSV");
      }else if(obj.GetDataPresent(DataFormats.Text)){
        str = obj.GetData(DataFormats.Text).ToString();
        if(editing && inlineEdit != null){
          if(str.IndexOf("\n") < 0){
            inlineEdit.Paste();
            return;
          }else{
            endEdit();
          }
        }
      }else{
        return;
      }

      ICassava clip;
      using(StringReader sr = new StringReader(str)){
        clip = CsvReader.Read(sr, format);
      }
      data.BeginUndoSequense();
      int rc = clip.GetRowCount();
      int cc = clip.GetColCount();
      int T = Col;
      int L = Row;
      for(int y=1; y<=rc; y++){
        for(int x=1; x<=cc; x++){
          int xx = x + T - 1;
          int yy = y + L - 1;
          data.SetCell(xx, yy, clip.GetCell(x, y));
        }
      }
      data.EndUndoSequense();
      pnlMain.Refresh();
    }

    #endregion
	}
}
