using System;
using System.Data;
using System.IO;
using System.Text;

namespace Asukaze.CassavaNET.IO
{
	/// <summary>
	///  CSVt@Cǂݍ݂܂B
	/// </summary>
	public class CsvReader
	{
    private TextReader reader;
		private string sepChars;
    private string weakSepChars;
		private string quoteChars;
    private int crlfCount = 0;
    private int lfCount = 0;
    private int crCount = 0;

		public CsvReader(TextReader csv, FileFormat format) {
    	reader = csv;
	   	sepChars = format.SepChars;
      weakSepChars = format.WeakSepChars;
      quoteChars = format.QuoteChars;
      while(weakSepChars.IndexOf((char)reader.Peek()) >= 0){
        reader.Read();
      }
    }

		private bool isnewline(char c) { return (c=='\n' || c=='\r'); }

    private bool normalchars(int i) {
    	char c = (char)i;
     	return (i >= 0 && weakSepChars.IndexOf(c) < 0 &&
      				sepChars.IndexOf(c) < 0 && !isnewline(c));
    }

    private string getquoted(char quote) {
      StringBuilder sb = new StringBuilder();
      int i;
      while((i = reader.Read()) >= 0){
        char ch = (char)i;
        if(ch == quote){
          if(reader.Peek() == quote){
           	reader.Read();
          }else{
            break;
          }
        }
      	sb.Append(ch);
      }
			return sb.ToString();
    }

    public string ReadNextCell(out bool hasMoreCol, out bool hasMoreRow) {
      StringBuilder sb = new StringBuilder();

      char ch = (char)reader.Peek();
			if(quoteChars.IndexOf(ch) >= 0){
      	reader.Read();
        sb.Append(getquoted(ch));
      }

    	while(normalchars(reader.Peek())){
     		sb.Append((char)reader.Read());
      }

      if(reader.Peek() < 0){
		    hasMoreCol = false;
  		  hasMoreRow = false;
       	return sb.ToString();
      }

 	    while(weakSepChars.IndexOf((char)reader.Peek()) >= 0){
       	reader.Read();
  		}
      if(sepChars.IndexOf((char)reader.Peek()) >= 0){
      	reader.Read();
		    while(weakSepChars.IndexOf((char)reader.Peek()) >= 0){
         	reader.Read();
        }
        hasMoreCol = true;
	  	  hasMoreRow = false;
        return sb.ToString();
  		}
    	if(isnewline((char)reader.Peek())){
        int x = reader.Read();
      	if(x == '\r' && reader.Peek() == '\n'){
        	reader.Read();
          crlfCount++;
        }else if(x == '\n'){
          lfCount++;
        }else if(x == '\r'){
          crCount++;
        }
	 	    while(weakSepChars.IndexOf((char)reader.Peek()) >= 0){
  	     	reader.Read();
  			}
	    	hasMoreCol = false;
  	  	hasMoreRow = (reader.Peek() >= 0);
        return sb.ToString();
		  }
 	  	hasMoreCol = (reader.Peek() >= 0);
  	  hasMoreRow = false;
      return sb.ToString();
    }

    public static CassavaImpl Read(TextReader csv, FileFormat format, out string nl) {
      CsvReader cr = new CsvReader(csv, format);
      CassavaImpl data = new CassavaImpl(1,1);
		  bool hasMoreCol, hasMoreRow;
      int x = 1, y = 1;
      do{
      	data.SetCell(x, y, cr.ReadNextCell(out hasMoreCol, out hasMoreRow));
				if(hasMoreRow){
         	y++;
          x = 1;
        }else if(hasMoreCol){
          x++;
        }else{
         	break;
        }
      }while(true);
      if(cr.crlfCount > cr.lfCount && cr.crlfCount > cr.crCount){
        nl = "\r\n";
      }else if(cr.lfCount > cr.crCount){
        nl = "\n";
      }else{
        nl = "\r";
      }
      return data;
		}

    public static CassavaImpl Read(TextReader csv, FileFormat format) {
      string nl;
      return Read(csv, format, out nl);
    }
  }
}
