using System;

namespace Asukaze.CassavaNET
{
	public class Range
	{
      public int Left, Top, Right, Bottom;
      public Range(){ }
      public Range(int left, int top, int right, int bottom){
        SetValue(left, top, right, bottom);
      }
      public Range(Range r){
        SetValue(r.Left, r.Top, r.Right, r.Bottom);
      }
      public void SetValue(int left, int top, int right, int bottom){
        Left   = Math.Min(left, right);
        Top    = Math.Min(top, bottom);
        Right  = Math.Max(left, right);
        Bottom = Math.Max(top, bottom);
	    }
      public bool Inside(int x, int y){
        return (Left <= x && x <= Right && Top <= y && y <= Bottom);
      }
      public void move(int vx, int vy){
       	Left += vx; Top += vy;
        Right += vx; Bottom += vy;
      }
      public int Size{
        get{ return ((Right - Left + 1) * (Bottom - Top + 1)); }
      }
	}
}
